// noErfEllipse.h++

#ifndef _noErfEllipse_H_
#define _noErfEllipse_H_

#include <math.h>
#include "noErf/noErfBlob.h++"

class noErfEllipse : public noErfBlob
{
//     int inited;
//     qmVector y_obs;
//     qmMatrix covL_obs;
//     qmMatrix covR_obs;
//     real beta;
//     qmVector Trl;
//     qmUnitQuaternion Qrl;
//     qmMatrix Rrl;
//     int freeCount;
//     int freeMap[9];
public:
    static int verbose;
    // Mmts: (u,v)= center, (Suu,Svv,Suv)= variances & covariance
    // State: (tx,ty,tz)= center, (q)=rotation, (l)= stdev
    enum _mmts { UL, VL, SuuL, SvvL, SuvL, UR, VR, SuuR, SvvR, SuvR };
    enum _state { TX, TY, TZ, Q0, QX, QY, QZ, LX, LY, LZ };
    enum _dstate { DTX, DTY, DTZ, DWX, DWY, DWZ, DLX, DLY, DLZ };
    noErfEllipse()
      : noErfBlob() {} 
    ~noErfEllipse() {}

//     void forward( qmVectorRef& dy, 
// 		  qmVectorRef& t, 
// 		  qmUnitQuaternionRef& q,
// 		  qmVectorRef& l, // stdev
// 		  real b );
//     void forward( qmVectorRef& dy, qmVectorRef& x, real b );
    void _forward( qmVectorRef& dy, 
 		   const qmVectorRef& t, 
		   const qmMatrixRef& r, 
		   const qmMatrixRef& L2, 
		   const real b );
//     void jacobian( qmMatrixRef& J, const qmVectorRef& x, real b, 
// 		   const qmVectorRef& Tc, const qmMatrixRef& Rc );
    void _forwardBoth( qmVectorRef& y, const qmVectorRef& x );
    // void _jacobianBoth( qmMatrixRef& J, const qmVectorRef& x );
    virtual const qmVectorRef& operator()( const qmVectorRef& x );
//    virtual const qmMatrixRef& jacobian( const qmVectorRef& x );
//    virtual const qmVectorRef& add( const qmVectorRef& x, const qmVectorRef& dx );
};

#endif /* _noErfEllipse_H_ */
