// noErfExponential.h++

#ifndef _noErfExponential_H_
#define _noErfExponential_H_

#include <math.h>
#include "qmNonlinearOptimize/noErrorFunction.h++"

class noErfExponential : public noErrorFunction
{
    enum { AMPL = 0, RATE = 1, N = 2 };
    qmVector y;
public:
    noErfExponential() {}
    void init( qmVectorRef& y );
    const qmVectorRef& operator()( const qmVectorRef& x );
    const qmMatrixRef& jacobian( const qmVectorRef& x );
    const qmVectorRef& add( const qmVectorRef& x, const qmVectorRef& dx );
    qmVectorRef& generateData( double a, double r, qmVectorRef& y_out );
};

#endif /* _noErfExponential_H_ */
