// IvCameraOverlayLine.h++

#ifndef _IvCameraOverlayLine_H_
#define _IvCameraOverlayLine_H_

#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoColorIndex.h>
#include <Inventor/nodes/SoCoordinate3.h>
#include <Inventor/nodes/SoIndexedLineSet.h>

class IvCameraOverlayLine
{
    SoSeparator* root;
    SoColorIndex* colorIndex;
    SoCoordinate3* endPoints;
    SoIndexedLineSet* connection;
public:
    IvCameraOverlayLine( float x0, float y0, float x1, float y1, int c = 1 )
      : root( new SoSeparator ),
	colorIndex( new SoColorIndex ),
	endPoints( new SoCoordinate3 ),
	connection( new SoIndexedLineSet )
    {
	root -> ref();
	root -> addChild( colorIndex );
	root -> addChild( endPoints );
	root -> addChild( connection );
	colorIndex -> index = (c>0 && c<=6) ? c : 1;
	endPoints -> point.set1Value( 0, x0, y0, 0. );
	endPoints -> point.set1Value( 1, x1, y1, 0. );
	connection -> coordIndex.set1Value( 0, 0 );
	connection -> coordIndex.set1Value( 1, 1 );
	connection -> coordIndex.set1Value( 2, -1 );
    }
    ~IvCameraOverlayLine() { root -> unref(); }
    inline void redraw( float x0, float y0, float x1, float y1, int c = 1 )
    {
	colorIndex -> index = (c>0 && c<=6) ? c : 1;
	endPoints -> point.set1Value( 0, x0, y0, 0. );
	endPoints -> point.set1Value( 1, x1, y1, 0. );
    }	
    inline operator SoSeparator*() { return root; }
    inline SoSeparator* getNode() { return root; }
};

#endif /* _IvCameraOverlayLine_H_ */
