// IvUtil.c++

#include "IvUtil.h++"

ostream&
IvUtil::printMatrix( ostream& os, const SbMatrix& m )
{
    SbMatrix foo;
    m.getValue(foo);
    float* fp = (float *) foo;
    int count = 16;
    while( count-- )
       os << *fp++ << " ";
    os << endl;
    return os;
}

istream&
IvUtil::scanMatrix( istream& is, SbMatrix& m )
{
    float* fp = m;
    int count = 16;
    while( count-- )
       is >> *fp++;
    return is;
}

ostream&
IvUtil::printTransform( ostream& os, const SoTransform& t )
{
    SbVec3f translation = t.translation.getValue();
    SbRotation rotation = t.rotation.getValue();
    SbVec3f scale = t.scaleFactor.getValue();
    SbMatrix matrix;
    matrix.setTransform( translation, rotation, scale );
    return printMatrix( os, matrix );
}

istream&
IvUtil::scanTransform( istream& is, SoTransform& t )
{
    SbMatrix matrix;
    scanMatrix( is, matrix );
    t.setMatrix( matrix );
    return is;
}

