// ParseLineStream.h++

#ifndef _ParseLineStream_H_
#define _ParseLineStream_H_

#include <strstream.h>
#include <assert.h>

class ParseLineStream : public ostrstream
{
  char *itemBuffer;
  char *lineBuffer;
  int allocCount;
  ostrstream lineStream;
  ostream *streamP;
  streampos mark;
  char *prefix;
public:
  ParseLineStream( ostream& os, int length, char *p = "" )
    : ostrstream( new char[length], length ), 
	itemBuffer( str() ),
	lineBuffer( new char[length] ),
	allocCount( length ),
	lineStream( lineBuffer, length, ios::out ),
	streamP( &os ),
	mark( ios::beg ),
	prefix( (p) ? p : "" ) {}
  ~ParseLineStream() { delete itemBuffer; delete lineBuffer; }
  void Enter(); // puts Item on Line
  void Flush(); // puts Line on Stream
};

#endif /* _ParseLineStream_H_ */
