// qmArray.h++

#ifndef _qmArray_H_
#define _qmArray_H_

#include "QuickMath/qmArrayRef.h++"

template < class TRef_ >
class qmArray : public qmArrayRef<TRef_>
{
    void* allocMem;
 public:
    qmArray()
      : qmArrayRef<TRef_>(), allocMem( 0 ) {}
    qmArray( TRef_& r, int n )
      : qmArrayRef<TRef_>(), allocMem( 0 ) { set( r, n ); }
    ~qmArray() { if( allocMem ) delete []  allocMem; }
    void set( TRef_&, int );
};

template < class TRef_ >
void
qmArray<TRef_>::set( TRef_& tr, int n )
{
    if( allocMem )
       delete [] allocMem;
    qmArrayRef<TRef_>::set( tr, n, 0 );
    allocMem = new char*[ getByteCount() ];
    referTo( allocMem );
}

#endif /* _qmArray_H_ */
