// qmEigenStructure.h++

#ifndef _qmEigenStructure_H_
#define _qmEigenStructure_H_

// THIS CURRENTLY ONLY WORKS FOR SYMMETRIC MATRICES !!!!!!!!!!!!!

#include <math.h>
#include "QuickMath/qmMatrixRef.h++"
#include "QuickMath/qmMatrix.h++"
#include "QuickMath/qmVectorRef.h++"
#include "QuickMath/qmVector.h++"

class qmEigenStructure
{
    qmMatrix eigenVectors;
    qmVector eigenValues;

public:

    qmEigenStructure() {}
    qmEigenStructure( const qmMatrixRef& );
    qmEigenStructure& set( const qmMatrixRef& );
    qmMatrixRef& getEigVectors() { return eigenVectors; }
    qmVectorRef& getEigValues() { return eigenValues; }

    // !! eigenSymmetric2: evectors in ROWS
    // !! eigenSymmetric: evectors in COLUMNS

    static int eigenSymmetric2( const qmMatrixRef& sym2x2Mat,
				qmVectorRef& eValOut, 
				qmMatrixRef& eVecOut );
    static qmVectorRef& eigenSymmetric( const qmMatrixRef& symMat, 
					qmVectorRef& eValOut,
					qmMatrixRef& eVecOut );

};

typedef qmEigenStructure qmEig;

#endif /* _qmEigenStructure_H_ */
