// qmImageRef.h++

#ifndef _qmImageRef_H_
#define _qmImageRef_H_

class qmImageRef
{
    TRef_ ref;
    int size;
    int count;
    int width;
    void* mem;
    
 public:

    qmImageRef()
      : ref(), size(0), count(0), width(0), mem(0) {}
    qmImageRef( TRef_& r, int m, int n, void* p )
      : ref(), size(0), count(0), width(0), mem(0) { set( r, m, n, p ); }
    void set( TRef_&, int, int, void* );
    inline TRef_& operator[]( int, int );
    inline const TRef_& get( int, int ) const;
    qmImageRef<TRef_>& referTo( void* p ) { mem = p; return *this; }
    int getByteCount() { return( count*size ); }
    ostream& print( ostream& ) const;
};

template < class TRef_ >
void
qmImageRef<TRef_>::set( TRef_& tr, int m, int n, void* p )
{
    count = m*n;
    width = n;
    size = tr.getByteCount();
    mem = p;
    ref = tr;
    ref.referTo( mem );
}

template < class TRef_ >
inline
TRef_&
qmImageRef<TRef_>::operator[]( int i, int j )
{ 
    return ref.referTo( ((char*)mem) + ( i*width + j ) * size );
}

template < class TRef_ >
inline
const TRef_&
qmImageRef<TRef_>::get( int i, int j ) const
{
    TRef_ tmp = ref;
    return tmp.referTo( ((char*)mem) + ( i*width + j ) * size );
}

template < class TRef_ >
ostream&
qmArrayRef<TRef_>::print( ostream& os ) const
{
    for( int i = 0; i < count; )
       {
	   for( int j = 0; j < width; j++, i++ )
	      os << get(i,j) << endl;
	   os << endl;
       }
    return os;
}

template < class TRef_ >
ostream&
operator<<( ostream& os, const qmImageRef<TRef_>& ar )
{
    return ar.print( os );
}

#endif /* _qmImageRef_H_ */
