// qmTime.h++

#ifndef _qmTime_H_
#define _qmTime_H_

#define _BSD_TIME // so sgi is compatible with bsd
#include <sys/time.h>

class qmTime
{
    struct timeval tv;
    struct timezone tz;
    double tsec;

public:

    qmTime() 
      : tsec( get() ) { tz.tz_minuteswest=0; tz.tz_dsttime=0; }
    qmTime( double d ) 
      : tsec( d ) { tz.tz_minuteswest=0; tz.tz_dsttime=0; }
    qmTime( long sec, long usec )
      : tsec( double(sec)+double(usec)/1.e6 ) {
	  tz.tz_minuteswest=0; tz.tz_dsttime=0; }
    qmTime( const qmTime& t ) 
      : tsec( t.tsec ) { tz.tz_minuteswest=0; tz.tz_dsttime=0; }
    operator double() { return tsec; }
    operator struct timeval() { return getTimeVal(); }
    struct timeval getTimeVal() { tv.tv_sec = int(tsec); 
				  tv.tv_usec = int((tsec - tv.tv_sec)*1.e6);
				  return tv; }
    ostream& print( ostream& os ) { getTimeVal(); 
				    return( os << tv.tv_sec << " sec, "
					    << tv.tv_usec << " usec" ); }
    double get() { gettimeofday( &tv, &tz ); 
		   return( tv.tv_sec + tv.tv_usec/1.e6 ); }
    double set() { return( tsec = get() ); }
    void set( long sec, long usec ) { tsec=double(sec)+double(usec)/1.e6; }
    qmTime& operator/=( int N ) { tsec /= N; return *this; }
    qmTime& operator+=( qmTime& t ) { tsec += t.tsec; return *this; }
    qmTime& operator-=( qmTime& t ) { tsec -= t.tsec; return *this; }
    
};

#endif /* _qmTime_H_ */
