// RPCServer.c++

#include "RPCServer.h++"

int RPCServer::quitFlag = 0;

void
RPCServer::service_rpc()
{
    // ------------------------------------------------
    // This is a standard servicing routine (from trevor)
    fd_set readfds;
    int dtbsz = getdtablesize();
    struct timeval tt;
    tt.tv_sec = 2;
    tt.tv_usec = 0;
    readfds = svc_fdset;
    switch( select( dtbsz, &readfds, NULL, NULL, &tt ) ) 
       {
	  case -1:
	   if ( errno != EBADF )
	      break;
	   perror( "service_rpc (svc_run): select" );
	   return;
	  case 0:
	   break;
	  default:
	   svc_getreqset( &readfds );
       }
}

void
RPCServer::serverThread( void * )
{
    rpc_init();
    while( !quitFlag )
       service_rpc();
    exit( 0 ); 
    // Will send SIGCLD (child died) to main thread
}

#if defined(__alpha) || defined(IRIX64)
void
RPCServer::cleanup(int)
#else
void
RPCServer::cleanup(...)
#endif
{
    quitFlag = 1;
    exit( 0 );
}

#if defined(__alpha) || defined(IRIX64)
void cleanup_sig (int )
{
    exit( 0 );
}
#else
void cleanup_sig ( ... )
{
    exit( 0 );
}
#endif


RPCServer::RPCServer()
  : child_pid( -1 ) {}

int
RPCServer::start()
{
#ifdef SPROC
    // cerr << "Starting Server" << endl;
    signal( SIGCLD, cleanup_sig );
    unsigned int inh = PR_SALL | PR_SETEXITSIG;
    child_pid = sproc( serverThread, inh );
    if( -1 == child_pid )
       {
	   perror( "RPCServer: sproc failed" );
	   return 1;
       }
    return 0;
#else
    perror( "RPCServer: sproc not implemented" );
    return 1;
#endif
  }
