/***************************************************************************
 * 
 * Copyright 1995  by  the  Massachusetts Institute  of Technology.   All  
 * rights reserved.
 * 
 * Developed  by the Perceptual Computing Section 
 * at the Media Laboratory, MIT, Cambridge, Massachusetts.
 * 
 * Permission to use, copy,  or modify this software and  its documentation
 * for  educational  and  research purposes only and without fee  is hereby
 * granted, provided  that this copyright notice and the original authors's
 * names appear  on all copies and supporting documentation.  If individual
 * files are  separated from  this  distribution directory  structure, this
 * copyright notice must be included.  For any other uses of this software,
 * in original or  modified form, including but not limited to distribution
 * in whole or in  part, specific  prior permission  must be  obtained from
 * MIT.  These programs shall not  be  used, rewritten, or  adapted as  the
 *   basis  of  a commercial  software  or  hardware product  without first
 * obtaining appropriate licenses  from MIT.  MIT. makes no representations
 * about the suitability of this  software for any purpose.  It is provided
 * "as is" without express or implied warranty.
 * 
 **************************************************************************/

/* iveBitmap.h */

#ifndef _IVEBITMAP_H_
#define _IVEBITMAP_H_

#include <stdio.h>

typedef struct
{
  int height;
  int width;
  int byteCount;
  unsigned char *data;
} iveBitmap;

#define iveBitmapBit( bm, y, x ) \
   iveBitmapGetBit( bm, y, x )

extern iveBitmap *iveBitmapMake( int height, int width );
extern iveBitmap *iveBitmapMakeLoad( char *file );
extern int iveBitmapGetBit( iveBitmap *bm, int y, int x );
extern void iveBitmapPutBit( iveBitmap *bm, int y, int x, int val );
extern void iveBitmapSetBit( iveBitmap *bm, int y, int x );
extern void iveBitmapUnSetBit( iveBitmap *bm, int y, int x );
extern void iveBitmapZero( iveBitmap *bm );
extern void iveBitmapWriteImage( iveBitmap *bm, FILE *stream );

#include "iveBitmap.proto"

#endif /* _IVEBITMAP_H_ */
