// $CopyrightHeader$

// Copyright (C) 1996 by Ali Azarbayejani and the Massachusetts
// Institute of Technology
// Copyright (C) 1997 by Christopher R. Wren and the Massachusetts
// Institute of Technology
//
// COMMERCIAL DISCLAIMER:
//
// This software is intended for research purposes only and contains
// unlicensed software, in original and modified forms, from various
// sources including the Free Software Foundation.  These programs
// shall not be used, rewritten, or adapted as the basis of a
// commercial software or hardware product without first obtaining
// appropriate licenses from the owners of the original software
// copyrights.
//
// In the case of copyrighted software fragments obtained from the
// Free Software Foundation: you can redistribute it and/or modify it
// under the terms of the GNU Library General Public License as
// published by the Free Software Foundation.  This software is
// distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General
// Public License for more details.  You should have received a copy
// of the GNU Library General Public License and the GNU General
// Public License along with this software; if not, write to the Free
// Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.


// MIT COPYRIGHT:
// 
// Copyright 1995  by  the  Massachusetts Institute  of Technology.   All  
// rights reserved.
// 
// Developed  by Ali Azarbayejani at the Media Laboratory, MIT,
// Cambridge, Massachusetts.
// 
// Permission to use, copy,  or modify this software and  its documentation
// for  educational  and  research purposes only and without fee  is hereby
// granted, provided  that this copyright notice and the original authors's
// names appear  on all copies and supporting documentation.  If individual
// files are  separated from  this  distribution directory  structure, this
// copyright notice must be included.  For any other uses of this software,
// in original or  modified form, including but not limited to distribution
// in whole or in  part, specific  prior permission  must be  obtained from
// MIT.  These programs shall not  be  used, rewritten, or  adapted as  the
// basis  of  a commercial  software  or  hardware product  without first
// obtaining appropriate licenses  from MIT.  MIT. makes no representations
// about the suitability of this  software for any purpose.  It is provided
// "as is" without express or implied warranty.

// FfinderServer.c++

#include "FfinderServer.h++"
ffConfig FfinderServer::config;
int FfinderServer::captureFlag = 0;
int FfinderServer::doneFlag = 0;
ffPerson FfinderServer::person;
ffPerson FfinderServer::priors;
int FfinderServer::homeyLock = 0;
int FfinderServer::priorLock = 0;
int FfinderServer::currentMode = 0;
int FfinderServer::forceInit = 0;
float FfinderServer::quickPoints[12];
int *
ffquit_1( void *, struct svc_req * ) 
{
    static int quitFlag = 1; // does nothing !
    return &quitFlag;
}
int *
ffinit_1( ffConfig *pc, struct svc_req * )
{
    static int retval = 0;
    if( pc )
       FfinderServer::config = *pc;
    return &retval;
}
int *
ffframe_1(void *, struct svc_req *)
{
    FfinderServer::captureFlag = 1;
    FfinderServer::doneFlag = 0;
    return &FfinderServer::captureFlag;
}
#include <stream.h>
ffPerson *
ffget_frame_result_1(void *, struct svc_req *)
{
    int waitCount = 0;
    while( !FfinderServer::doneFlag && waitCount++ < 10 )
       sginap( 1 );
#if 1
    if( waitCount >= 10 )
       cerr << "ffget_frame_result_1: timed out" << endl;
#endif
    return &FfinderServer::person;
}

void *
ffset_priors_1(ffPerson *p, struct svc_req *)
{
    while( FfinderServer::priorLock )
      {
	sginap( 1 );
      }

    FfinderServer::priorLock = 1;
    FfinderServer::priors = *p;
    FfinderServer::priorLock = 0;
    
    static int rvalue = 0;
    return(&rvalue);
}

ffPerson *
ffget_current_1( void *, struct svc_req * )
{
    FfinderServer::currentMode = 1;
    return &FfinderServer::person;
}
void *
ffforceinit_1( void *, struct svc_req *)
{
    static int rvalue = 0;
    FfinderServer::forceInit = 1;
    return &rvalue;
}
ffQuickPoints *
ffgetquickpoints_1( void *, struct svc_req * )
{
    static ffQuickPoints qp;
    memcpy( qp.pts, FfinderServer::quickPoints, 12*sizeof(float) );
    return &qp;
}
FfinderServer::FfinderServer()
{
    init();
}
void
FfinderServer::init()
{
    person.leftHand.valid = 0;
    person.rightHand.valid = 0;
    person.head.valid = 0;

    priors.leftHand.valid = 0;
    priors.rightHand.valid = 0;
    priors.head.valid = 0;
}
void
FfinderServer::copy( const ffPerson& fp )
{
    if( !captureFlag && !currentMode )
       return;
    while( homeyLock )
       sginap( 0 );
    homeyLock = 1;
    person = fp;
    homeyLock = 0;
    doneFlag = 1;
    captureFlag = 0;
}
ffPerson& 
FfinderServer::copy_priors( )
{
  static ffPerson prior_tmp;
  
    while( priorLock )
       sginap( 1 );
    priorLock = 1;
    prior_tmp = priors;
    priorLock = 0;
    
    return (prior_tmp);
}

