// noErrorFunction.h++

#ifndef _noErrorFunction_H_
#define _noErrorFunction_H_

#include "QuickMath/QuickMath.h++"
#include <stream.h>

class noErrorFunction
{
protected:
    qmVector dy_return;
    qmVector x_return;
    qmMatrix J_return;
public:
    noErrorFunction()
      : dy_return(), x_return(), J_return() {}
    noErrorFunction( int ny, int nx, int ndx )
      : dy_return( ny ), x_return( nx ), J_return( ny, ndx ) {}
    void init( int ny, int nx, int ndx );
    int getNdy() { return dy_return.getLength(); }
    int getNx() { return x_return.getLength(); }
    int getNdx() { return J_return.getWidth(); }
    virtual const qmVectorRef& operator()( const qmVectorRef& x ) = 0;
    virtual const qmMatrixRef& jacobian( const qmVectorRef& x ) = 0;
    virtual const qmVectorRef& add( const qmVectorRef& x,
				    const qmVectorRef& dx ) = 0;
};

#endif /* _noErrorFunction_H_ */
