// noIterativeReweightedLeastSquares.h++

#ifndef _noIterativeReweightedLeastSquares_H_
#define _noIterativeReweightedLeastSquares_H_

#include "qmNonlinearOptimize/noErrorFunction.h++"
#include "QuickMath/QuickMath.h++"

class noIterativeReweightedLeastSquares
{
    noErrorFunction* erf;
    qmVector x;
    qmVector dy;
    qmMatrix J;
    qmMatrix Ri;
    qmMatrix Pi;
    qmMatrix JtRi;
    qmMatrix tmp;
    qmMatrix paren;
    qmMatrix pseudoinverse;
    qmVector dx;
    real absTolerance;
    int verbose;
    int iterationLimit;
    static real defaultAbsTolerance;

public:

    noIterativeReweightedLeastSquares();
    void init( noErrorFunction& a );
    const qmVectorRef& estimate();
    // inline void setGradientTolerance( real );
    inline void setAbsoluteTolerance( real t ) { absTolerance = t; }
    inline void setState( qmVectorRef& v ) { x.copy( v ); }
    inline void setVerbose( int v = 1 ) { verbose = v; }
    inline void setIterationLimit( int l ) { iterationLimit = l; }
};

typedef noIterativeReweightedLeastSquares noIRWLS;

#endif /* _noIterativeReweightedLeastSquares_H_ */
