// noYakkaYakka.h++

#ifndef _noYakkaYakka_H_
#define _noYakkaYakka_H_

#include "qmNonlinearOptimize/noOptimizer.h++"
#include "qmNonlinearOptimize/noErrorFunction.h++"
#include "QuickMath/QuickMath.h++"

class noYakkaYakka : public noOptimizer
{
    noErrorFunction* erf;
    qmVector xP;
    qmVector xE;
    qmVector dX;	
    // qmVector yP;
    qmVector dY;
    qmMatrix Pp;
    qmMatrix Pe;
    qmMatrix K;
    qmMatrix I;
    qmMatrix tempNxP;
    qmMatrix tempNxN;
    qmMatrix tempPxP;
    int verbose;
 public:
    // Leave these public so the user can initialize or change them
    qmMatrix H;
    qmMatrix Phi;
    qmMatrix Q;
    qmMatrix R;
    
 public:
    void init( noErrorFunction& a );
    const qmVectorRef& estimate();
    inline void setState( qmVectorRef& x ) { xP.copy( x ); }
    inline void setCovariance( qmMatrixRef& P ) { Pp.copy( P ); }
    const qmMatrixRef& getCovariance() { return Pp; }
    inline void setVerbose( int v = 1 ) { verbose = v; }
};

#endif /* _noYakkaYakka_H_ */
