// qmGaussianInv.h++

#ifndef _qmGaussianInv_H_
#define _qmGaussianInv_H_

#include "QuickMath/QuickMath.h++"
#include "qmStatistics/qmGaussianInvRef.h++"

class qmGaussianInv : public qmGaussianInvRef
{
    real* allocArray;  // n + n*n = (n+1)n
public:
    qmGaussianInv()
      : qmGaussianInvRef(), allocArray( 0 ) {}
    qmGaussianInv( const int n );
    qmGaussianInv( const qmVectorRef&, const qmMatrixRef& );
    ~qmGaussianInv() { if (allocArray) delete allocArray; } 
    qmGaussianInv& set( const int n );
    qmGaussianInv& set( const qmVectorRef&, const qmMatrixRef& );
};

#endif /* _qmGaussianInv_H_ */
