// BlobAxes.c++

#include "BlobAxes.h++"

BlobAxes::BlobAxes()
  : root( new SoSeparator ),
    material( new SoMaterial ),
    endPoints( new SoCoordinate3 ),
    connection( new SoIndexedLineSet )
{
    static const float xyz[6][3] = { {-1.5,0,0}, {1.5,0,0},
					 {0,-1.5,0}, {0,1.5,0},
					 {0,0,-1.5}, {0,0,1.5} };
    static const int32_t conn[9] = { 0, 1, -1, 2, 3, -1, 4, 5, -1 };
    root -> ref();
    root -> addChild( material );
    root -> addChild( endPoints );
    root -> addChild( connection );
    material -> diffuseColor.setValue( 1,1,1 );
    material -> ambientColor.setValue( 1,1,1 );
    endPoints -> point.setValues( 0, 6, xyz );
    connection -> coordIndex.setValues( 0, 9, conn );
}
