// Hand.c++

#include "Hand.h++"
#include <stream.h>

SoNode* Hand::handGeometry = 0;

Hand::Hand()
  : root( new SoSeparator ),
    material( new SoMaterial ),
    xform( new SoTransform )
{
    if( !handGeometry )
       {
	   SoCube* tmp = new SoCube;
	   tmp -> ref();
	   tmp -> width = .4;
	   tmp -> height = .4;
	   tmp -> depth = .4;
	   handGeometry = tmp;
       }
    root -> ref();
    root -> addChild( xform );
    root -> addChild( material );
    root -> addChild( handGeometry );
    xform -> translation.setValue( 1.2, 0, 0 );
    material -> diffuseColor.setValue( .65, .15, 1 );
    material -> ambientColor.setValue( .65, .15, 1 );
}

void
Hand::set( int whichAxis, int plusOrMinus )
{
    // !! not checking bounds
    xform -> translation.setValue
       ( ( 0 == whichAxis ) ? (( plusOrMinus ) ? -1.2 : 1.2) : 0.,
	 ( 1 == whichAxis ) ? (( plusOrMinus ) ? -1.2 : 1.2) : 0.,
	 ( 2 == whichAxis ) ? (( plusOrMinus ) ? -1.2 : 1.2) : 0. );
}
