// SffinderServer.c++

#include "SffinderServer.h++"

#include <mutex.h>
enum {LOCKED = 0, UNLOCKED = 1};

sffPerson SffinderServer::homey;
sffPersonPlus SffinderServer::homeyPlus;
int SffinderServer::undumpFlag = 0;
int SffinderServer::sleepFlag = 0;
unsigned long SffinderServer::homeyLock;

static Lock(unsigned long *lock)
{
  while( atomic_op(test_and_set, lock, LOCKED) == LOCKED)
    sginap(0);
}

static Unlock(unsigned long *lock)
{
  atomic_op(test_and_set, lock, UNLOCKED);
}

// ------------------------------------------------
// Server-side stubs for the sffinder 

int *
sffquit_1(void *, struct svc_req *)
{
    static int retval = 0;
    // cleanup();
    return &retval;
}

sffPerson *
sffgetperson_1(void *, struct svc_req *)
{
    static sffPerson localHomey;
    Lock(&SffinderServer::homeyLock);
    localHomey = SffinderServer::homey;
    Unlock(&SffinderServer::homeyLock);
    return &localHomey;
}

sffPersonPlus *
sffgetpersonplus_1(void *, struct svc_req *)
{
    static sffPersonPlus localHomey;
    Lock(&SffinderServer::homeyLock);
    localHomey = SffinderServer::homeyPlus;
    Unlock(&SffinderServer::homeyLock);
    return &localHomey;
}

sffPersonPlus *
sffgetnextpersonplus_1( int *tlast, struct svc_req * )
{
    static sffPersonPlus localHomeyPlus;
    // while( SffinderServer::homeyPlus.frameNumber <= *tlast )
    while( SffinderServer::homeyPlus.frameNumber == *tlast )
       sginap( 1 );
    Lock(&SffinderServer::homeyLock);
    localHomeyPlus = SffinderServer::homeyPlus;
    Unlock(&SffinderServer::homeyLock);
    return &localHomeyPlus;
}

sffPerson *
sffgetnextperson_1( int *tlast, struct svc_req * )
{
    static sffPerson localHomey;
    while( SffinderServer::homey.frameNumber == *tlast )
       sginap( 2 );
    Lock(&SffinderServer::homeyLock);
    localHomey = SffinderServer::homey;
    Unlock(&SffinderServer::homeyLock);
    return &localHomey;
}

int *
sffundumpnext_1(void *, struct svc_req *)
{
    static int rvalue = 0;
    SffinderServer::undumpFlag = 1;
    return &rvalue;
}

int *
sffgetpersonexists_1( void *, struct svc_req * )
{
    static int rvalue = 0;
    rvalue = SffinderServer::homeyPlus.personExists;
    return &rvalue;
}

SffinderServer::SffinderServer()
{
    init();
}

#include <limits.h>
#include <sys/types.h>
#include <sys/prctl.h>
#include <sys/schedctl.h>

void
SffinderServer::init()
{
    schedctl( NDPRI, child_pid, NDPHIMAX );
    homey.leftHand.valid = 0;
    homey.rightHand.valid = 0;
    homey.head.valid = 0;
    homeyPlus.head.valid = 0;
    homeyPlus.leftHand.valid = 0;
    homeyPlus.rightHand.valid = 0;
    Unlock(&homeyLock);
}

void
SffinderServer::copy( const sffPersonPlus& spp )
{
  Lock(&homeyLock);
  homeyPlus = spp;
  Unlock(&homeyLock);
}

void
SffinderServer::copy( const sffPerson& spp )
{
  Lock(&homeyLock);
  homey = spp;
  Unlock(&homeyLock);
}

void *
sffsleep_1( void *, struct svc_req * )
{
    int garbage;
    SffinderServer::sleepFlag = 1;
    return &garbage;
}
    
void *
sffwakeup_1( void *, struct svc_req * )
{
    int garbage;
    kill( getppid(), SIGUSR1 );
    return &garbage;

}


