/* Version 1 */

struct sffImagePoint
{
    int valid;
    double t[2];
    double c[4];
    double angle;
    double s[2];
};

struct sffWorldBlob
{
    double t[3];
    double q[4];
    double s[3];
};

struct sffWorldPart
{
    int valid;
    sffWorldBlob camera_ref;
    sffWorldBlob world_ref;
    sffImagePoint left;
    sffImagePoint right;
};

struct sffPersonPlus
{
    long frameNumber;
    long timestampSec;
    long timestampUsec;
    int personExists;
    sffWorldPart leftHand;
    sffWorldPart rightHand;
    sffWorldPart head;
};

struct sffWorldPoint
{
    int valid;
    float x;
    float y;
    float z;
};

struct sffPerson
{
    long frameNumber;
    long timestampSec;
    long timestampUsec;
    int personExists;
    sffWorldPoint leftHand;
    sffWorldPoint rightHand;
    sffWorldPoint head;
};

/* Version 2 */

struct sffBlob2_s
{
    double t[2];
    double c[4];
    double angle;
    double s[2];
};

union sffBlob2 switch ( int valid )
{
  case 1: sffBlob2_s data;
  case 0: void;
  default: void;
};

struct sffBlob3_s
{
    double t[3];
    double q[4];
    double s[3];
};

struct sffPart_s
{
    sffBlob3_s camera_ref;
    sffBlob3_s world_ref;
    sffBlob2_s left;
    sffBlob2_s right;
};

union sffPart switch ( int valid )
{
  case 1: sffPart_s data;
  case 0: void;
  default: void;
};

enum sffWhichPart { SFF_HEAD, SFF_LHAND, SFF_RHAND };

struct sffBlobPerson
{
    long frameNumber;
    long timestampSec;
    long timestampUsec;
    int personExists;
    sffPart parts[3];
};

struct sffPoint3_s
{
    float xyz[3];
};

struct sffPointPerson
{
    long frameNumber;
    long timestampSec;
    long timestampUsec;
    int personExists;
    sffPoint3_s parts[3];
};

program SFFINDERPROG {
    version SFFINDERVERS {
	int sffQUIT( void ) = 0;
	sffPerson sffGETPERSON( void ) = 1;
	sffPersonPlus sffGETPERSONPLUS( void ) = 4;
	sffPersonPlus sffgetnextpersonplus( int ) = 2;
	int sffUNDUMPNEXT( void ) = 3;
	void sffsleep( void ) = 6;
	void sffwakeup( void ) = 7;
	int sffgetpersonexists( void ) = 8;
	sffPerson sffgetnextperson( int ) = 9;
    } = 1;
/*
    version SFFINDERVERS2 {
	sffPointPerson sffgetpointperson = 1;
	sffPointPerson sff
	sffPerson sffGETPERSON( void ) = 1;
	sffPersonPlus sffGETPERSONPLUS( void ) = 4;
	sffPersonPlus sffgetnextpersonplus( int ) = 2;
	int sffUNDUMPNEXT( void ) = 3;
	void sffsleep( void ) = 6;
	void sffwakeup( void ) = 7;
	int sffgetpersonexists( void ) = 8;
	sffPerson sffgetnextperson( int ) = 9;
    } = 2;
    */
} = 0x20000097;
